    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import  org.apache.bcel.Constants;
    58  import  java.io.*;
    59
    60  /***
    61   * This class represents a stack map attribute used for
    62   * preverification of Java classes for the <a
    63   * href="http://java.sun.com/j2me/"> Java 2 Micro Edition</a>
    64   * (J2ME). This attribute is used by the <a
    65   * href="http://java.sun.com/products/cldc/">KVM</a> and contained
    66   * within the Code attribute of a method. See CLDC specification
    67   * §5.3.1.2
    68   *
    69   * @version $Id: StackMap.java,v 1.2 2002/03/11 16:16:35 mdahm Exp $
    70   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    71   * @see     Code
    72   * @see     StackMapEntry
    73   * @see     StackMapType
    74   */
    75  public final class StackMap extends Attribute implements Node {
    76    private int             map_length;
    77    private StackMapEntry[] map; // Table of stack map entries
    78
    79    /*
    80     * @param name_index Index of name
    81     * @param length Content length in bytes
    82     * @param map Table of stack map entries
    83     * @param constant_pool Array of constants
    84     */
    85    public StackMap(int name_index, int length,  StackMapEntry[] map,
    86  		  ConstantPool constant_pool)
    87    {
    88      super(Constants.ATTR_STACK_MAP, name_index, length, constant_pool);
    89
    90      setStackMap(map);
    91    }
    92
    93    /***
    94     * Construct object from file stream.
    95     * @param name_index Index of name
    96     * @param length Content length in bytes
    97     * @param file Input stream
    98     * @throws IOException
    99     * @param constant_pool Array of constants
    100    */
    101   StackMap(int name_index, int length, DataInputStream file,
    102 	   ConstantPool constant_pool) throws IOException
    103   {
    104     this(name_index, length, (StackMapEntry[])null, constant_pool);
    105
    106     map_length = file.readUnsignedShort();
    107     map = new StackMapEntry[map_length];
    108
    109     for(int i=0; i < map_length; i++)
    110       map[i] = new StackMapEntry(file, constant_pool);
    111   }
    112
    113   /***
    114    * Dump line number table attribute to file stream in binary format.
    115    *
    116    * @param file Output file stream
    117    * @throws IOException
    118    */
    119   public final void dump(DataOutputStream file) throws IOException
    120   {
    121     super.dump(file);
    122     file.writeShort(map_length);
    123     for(int i=0; i < map_length; i++)
    124       map[i].dump(file);
    125   }
    126
    127   /***
    128    * @return Array of stack map entries
    129    */
    130   public final StackMapEntry[] getStackMap() { return map; }
    131
    132   /***
    133    * @param map Array of stack map entries
    134    */
    135   public final void setStackMap(StackMapEntry[] map) {
    136     this.map = map;
    137
    138     map_length = (map == null)? 0 : map.length;
    139   }
    140
    141   /***
    142    * @return String representation.
    143    */
    144   public final String toString() {
    145     StringBuffer buf = new StringBuffer("StackMap(");
    146
    147     for(int i=0; i < map_length; i++) {
    148       buf.append(map[i].toString());
    149
    150       if(i < map_length - 1)
    151 	buf.append(", ");
    152     }
    153
    154     buf.append(')');
    155
    156     return buf.toString();
    157   }
    158
    159   /***
    160    * @return deep copy of this attribute
    161    */
    162   public Attribute copy(ConstantPool constant_pool) {
    163     StackMap c = (StackMap)clone();
    164
    165     c.map = new StackMapEntry[map_length];
    166     for(int i=0; i < map_length; i++)
    167       c.map[i] = map[i].copy();
    168
    169     c.constant_pool = constant_pool;
    170     return c;
    171   }
    172
    173   /***
    174    * Called by objects that are traversing the nodes of the tree implicitely
    175    * defined by the contents of a Java class. I.e., the hierarchy of methods,
    176    * fields, attributes, etc. spawns a tree of objects.
    177    *
    178    * @param v Visitor object
    179    */
    180    public void accept(Visitor v) {
    181      v.visitStackMap(this);
    182    }
    183
    184   public final int getMapLength() { return map_length; }
    185 }

This page was automatically generated by Maven